tbb::flow::interface11::broadcast_node< T > Class Template Reference

Forwards messages of type T to all successors. More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::broadcast_node< T >:
Collaboration diagram for tbb::flow::interface11::broadcast_node< T >:

## Public Types

typedef T | input_type
typedef T | output_type
typedef receiver< input_type >::predecessor_type | predecessor_type
typedef sender< output_type >::successor_type | successor_type
Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

__TBB_NOINLINE_SYM | broadcast_node (graph &g)
__TBB_NOINLINE_SYM | broadcast_node (const broadcast_node &src)
bool | register_successor (successor_type &r) __TBB_override
| Adds a successor. More...
bool | remove_successor (successor_type &r) __TBB_override
| Removes s as a successor. More...
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from tbb::flow::interface11::receiver< T >
bool | try_put (const typename internal::async_helpers< T >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< T >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...
Public Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get (T &)
| Request an item from the sender. More...
virtual bool | try_reserve (T &)
| Reserves an item in the sender. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()
virtual bool | try_release ()
| Releases the reserved item. More...
virtual bool | try_consume ()
| Consumes the reserved item. More...

## Protected Member Functions

task * | try_put_task (const T &t) __TBB_override
| build a task to run the successor if possible. Default is old behavior. More...
graph & | graph_reference () const __TBB_override
void | reset_receiver (reset_flags) __TBB_override
| put receiver back in initial state More...
void | reset_node (reset_flags f) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::receiver< T >
virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual bool | is_continue_receiver ()
Protected Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Private Attributes

internal::broadcast_cache< input_type > | my_successors

## Friends

template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::receiver< T >
__TBB_DEPRECATED typedef T | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Public Attributes inherited from tbb::flow::interface11::sender< T >
__TBB_DEPRECATED typedef T | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Detailed Description

### template<typename T>
class tbb::flow::interface11::broadcast_node< T >

Forwards messages of type T to all successors.

Definition at line 1905 of file flow_graph.h.

## Member Typedef Documentation

## input_type

template<typename T >

typedef T tbb::flow::interface11::broadcast_node< T >::input_type

Definition at line 1907 of file flow_graph.h.

## output_type

template<typename T >

typedef T tbb::flow::interface11::broadcast_node< T >::output_type

Definition at line 1908 of file flow_graph.h.

## predecessor_type

template<typename T >

typedef receiver<input_type>::predecessor_type tbb::flow::interface11::broadcast_node< T >::predecessor_type

Definition at line 1909 of file flow_graph.h.

## successor_type

template<typename T >

typedef sender<output_type>::successor_type tbb::flow::interface11::broadcast_node< T >::successor_type

Definition at line 1910 of file flow_graph.h.

## Constructor & Destructor Documentation

## broadcast_node() [1/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::broadcast_node< T >::broadcast_node | ( | graph & | g | ) |

inline explicit

Definition at line 1923 of file flow_graph.h.

: graph_node(g) {
my_successors.set_owner( this );
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_BROADCAST_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), static_cast<sender<output_type> *>(this) );
}
CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::internal::fgt_node
static void fgt_node(void *, string_index, void *, void *)
Definition: _flow_graph_trace_impl.h:326
tbb::flow::interface11::broadcast_node::my_successors
internal::broadcast_cache< input_type > my_successors
Definition: flow_graph.h:1916
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:888

References CODEPTR, tbb::internal::fgt_node(), tbb::flow::interface11::graph_node::my_graph, and tbb::flow::interface11::broadcast_node< T >::my_successors.

Here is the call graph for this function:

## broadcast_node() [2/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::broadcast_node< T >::broadcast_node | ( | const broadcast_node< T > & | src | ) |

inline

Definition at line 1937 of file flow_graph.h.

:
graph_node(src.my_graph), receiver<T>(), sender<T>()
{
my_successors.set_owner( this );
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_BROADCAST_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), static_cast<sender<output_type> *>(this) );
}

References CODEPTR, tbb::internal::fgt_node(), tbb::flow::interface11::graph_node::my_graph, and tbb::flow::interface11::broadcast_node< T >::my_successors.

Here is the call graph for this function:

## Member Function Documentation

## graph_reference()

template<typename T >

graph& tbb::flow::interface11::broadcast_node< T >::graph_reference | ( |  | ) | const

inline protected virtual

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 2025 of file flow_graph.h.

{
return my_graph;
}

References tbb::flow::interface11::graph_node::my_graph.

## register_successor()

template<typename T >

bool tbb::flow::interface11::broadcast_node< T >::register_successor | ( | successor_type & | r | ) |

inline virtual

Adds a successor.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 1952 of file flow_graph.h.

{
my_successors.register_successor( r );
return true;
}

References tbb::flow::interface11::broadcast_node< T >::my_successors.

## remove_successor()

template<typename T >

bool tbb::flow::interface11::broadcast_node< T >::remove_successor | ( | successor_type & | r | ) |

inline virtual

Removes s as a successor.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 1958 of file flow_graph.h.

{
my_successors.remove_successor( r );
return true;
}

References tbb::flow::interface11::broadcast_node< T >::my_successors.

## reset_node()

template<typename T >

void tbb::flow::interface11::broadcast_node< T >::reset_node | ( | reset_flags | f | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 2031 of file flow_graph.h.

{
if (f&rf_clear_edges) {
my_successors.clear();
#if TBB_DEPRECATED_FLOW_NODE_EXTRACTION
my_built_predecessors.clear();
#endif
}
__TBB_ASSERT(!(f & rf_clear_edges) || my_successors.empty(), "Error resetting broadcast_node");
}
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::flow::interface11::rf_clear_edges
@ rf_clear_edges
Definition: _flow_graph_impl.h:161

References __TBB_ASSERT, tbb::flow::interface11::broadcast_node< T >::my_successors, and tbb::flow::interface11::rf_clear_edges.

## reset_receiver()

template<typename T >

void tbb::flow::interface11::broadcast_node< T >::reset_receiver | ( | reset_flags | f | ) |

inline protected virtual

put receiver back in initial state

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 2029 of file flow_graph.h.

{}

## try_put_task()

template<typename T >

task* tbb::flow::interface11::broadcast_node< T >::try_put_task | ( | const T & | t | ) |

inline protected virtual

build a task to run the successor if possible. Default is old behavior.

Implements tbb::flow::interface11::receiver< T >.

Definition at line 2019 of file flow_graph.h.

{
task *new_task = my_successors.try_put_task(t);
if (!new_task) new_task = SUCCESSFULLY_ENQUEUED;
return new_task;
}
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
tbb::flow::internal::SUCCESSFULLY_ENQUEUED
static tbb::task *const SUCCESSFULLY_ENQUEUED
Definition: _flow_graph_impl.h:61

References tbb::flow::interface11::broadcast_node< T >::my_successors, and tbb::flow::internal::SUCCESSFULLY_ENQUEUED.

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename T >
template<typename X , typename Y >

friend class internal::broadcast_cache

friend

Definition at line 2016 of file flow_graph.h.

## internal::round_robin_cache

template<typename T >
template<typename X , typename Y >

friend class internal::round_robin_cache

friend

Definition at line 2017 of file flow_graph.h.

## run_and_put_task

template<typename T >
template<typename R , typename B >

friend class run_and_put_task

friend

Definition at line 2015 of file flow_graph.h.

## Member Data Documentation

## my_successors

template<typename T >

internal::broadcast_cache<input_type> tbb::flow::interface11::broadcast_node< T >::my_successors

private

Definition at line 1916 of file flow_graph.h.

Referenced by tbb::flow::interface11::broadcast_node< T >::broadcast_node(), tbb::flow::interface11::broadcast_node< T >::register_successor(), tbb::flow::interface11::broadcast_node< T >::remove_successor(), tbb::flow::interface11::broadcast_node< T >::reset_node(), and tbb::flow::interface11::broadcast_node< T >::try_put_task().

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.